import React from 'react'
import * as mobx from 'mobx'
import {
    inject,
    observer
} from 'mobx-react'
import {
    WeaTop,
    WeaTab,
    WeaFormItem,
    WeaRightMenu,
    WeaAlertPage
} from 'ecCom'
import {
    Row,
    Col,
    Spin,
    Modal,
    Button,
    message,
    Switch
} from 'antd'
import {
    WeaSwitch,
    WeaTableNew
} from 'comsMobx'
import {
    i18n
} from '../../public/i18n';

import '../../style/common.less';

import NewAndEditDialog from '../NewAndEditDialog';
import { renderNoright } from '../../util'; // 从util文件引入公共的方法



const toJS = mobx.toJS;
const confirm = Modal.confirm;
const WeaTable = WeaTableNew.WeaTable;


@inject('rankScheme')
@observer
export default class RankScheme extends React.Component {
    constructor(props) {
        super(props);
    }

    componentWillMount() {
    }

    componentDidMount() {
        this.init();
    }

    componentWillUnmount() {
    }


    componentWillReceiveProps(nextProps) {
        const {
            rankScheme
        } = this.props;

        if (this.props.location.key !== nextProps.location.key) {
            this.init();
        }
    }

    init() {
        const {
            rankScheme
        } = this.props;
        rankScheme.getTableInfo();
        rankScheme.getHasRight();
    }

    getTopMenuBtns() {
        const {
            rankScheme
        } = this.props;
        const {
            topMenu,
            tableStore
        } = rankScheme;

        let btns = [];
        topMenu.map((item, i) => {
            if (item.menuFun !== 'batchDelete') {
                btns.push(<Button type='primary' onClick={() => this.handleClick(item)}>{item.menuName}</Button>);
            } else {
                btns.push(<Button type='primary' onClick={() => this.handleClick(item)} disabled={tableStore.selectedRowKeys.length > 0 ? false : true} >{item.menuName}</Button>);
            }

        });

        return btns;
    }

    handleClick(item) {
        const {
            rankScheme
        } = this.props;
        const {
            isPanelShow
        } = rankScheme;

        isPanelShow && rankScheme.setPanelStatus(false);
        this[item.menuFun] && this[item.menuFun]();
    }

    new() {
        const {
            rankScheme
        } = this.props;

        rankScheme.setNeDialogTitle(i18n.label.newRankScheme());
        rankScheme.setIsNew(true);
        rankScheme.setVisible(true);
        rankScheme.getForm();
    }

    batchDelete() {
        const {
            rankScheme
        } = this.props;
        const {
            tableStore
        } = rankScheme;

        let keys = toJS(tableStore.selectedRowKeysAllPages).toString();
        rankScheme.setIds(keys);
        this.showConfirm('batchDel');
    }
    showConfirm(v) {
        let _this = this;
        confirm({
            title: i18n.confirm.defaultTitle(),
            content: (v == 'del') ? i18n.confirm.delete() : i18n.confirm.batchDeleteConfirm(),
            okText: i18n.button.ok(),
            cancelText: i18n.button.cancel(),
            onOk() {
                _this.onOk();
            },
            onCancel() {
                return false;
            },
        });
    }
    onOk() {
        const {
            rankScheme
        } = this.props;
        rankScheme.delete();
    }


    getDropMenuDatas() {
        const {
            rankScheme
        } = this.props;
        const {
            rightMenu
        } = rankScheme;

        let menus = [];
        toJS(rightMenu).map((item, index) => {
            let obj = {
                key: item.menuFun,
                icon: <i className={`${item.menuIcon}`} />,
                content: item.menuName,
            }
            if (item.menuFun == 'collection' || item.menuFun == 'help' || item.menuFun == 'pageAddress') {
                obj.disabled = true;
            }
            menus.push(obj);
        })
        return menus;
    }

    handleMenuClick(key) {
        const {
            rankScheme
        } = this.props;
        const {
            isPanelShow
        } = rankScheme;

        isPanelShow && rankScheme.setPanelStatus(false);
        this[key] && this[key]();
    }

    getTabBtn() {
        const {
            rankScheme
        } = this.props;
        const {
            form2
        } = rankScheme;

        const btn = [
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@bx87i8`} type="primary" onClick={() => {
                rankScheme.getTableInfo(); rankScheme.setPanelStatus(false)
            }}>{i18n.button.search()}</Button>),
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@218ju6`} onClick={() => form2.reset()}>{i18n.button.reset()}</Button>),
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@5u9mfz`} onClick={() => rankScheme.setPanelStatus(false)}>{i18n.button.cancel()}</Button>),
        ];

        return btn;
    }

    custom = () => {
        const {
            rankScheme
        } = this.props, {
            tableStore,
        } = rankScheme;

        tableStore.setColSetVisible(true);
        tableStore.tableColSet(true);
    }

    onSearchChange(val) {
        const {
            rankScheme
        } = this.props;
        const {
            form2
        } = rankScheme;

        rankScheme.setSchemeName(val);
        !this.isEmptyObject(form2.getFormParams()) && rankScheme.updateFields(val);
    }

    reRenderColumns(columns) {
        let _this = this;
        columns.forEach((c, index) => {
            if (c.dataIndex == 'forbidden_tag') {
                c.render = function (text, record) {
                    return <Switch checked={record.forbidden_tag == "0" ? true : false} onChange={checked => _this.updateForbiddenTag(checked, record.id)} />
                }
            };
        })
    }

    updateForbiddenTag(checked, id) {
        const {
            rankScheme
        } = this.props;
        confirm({
            title: i18n.confirm.defaultTitle(),
            content: (checked == true) ? i18n.confirm.enableTag() : i18n.confirm.forbiddenTag(),
            okText: i18n.button.ok(),
            cancelText: i18n.button.cancel(),
            onOk() {
                rankScheme.updateForbiddenTag(checked, id);
            },
            onCancel() {
                return false;
            },
        });

    }

    onOperatesClick(record, rowIndex, operate) {
        const {
            index
        } = operate;
        (index == '0') && this.doEdit(record.randomFieldId);
        (index == '1') && this.doDel(record.randomFieldId);

    }

    doEdit(id) {
        const {
            rankScheme
        } = this.props;

        rankScheme.setNeDialogTitle(i18n.label.editRankScheme());
        rankScheme.setSchemeId(id);
        rankScheme.setIsNew(false);
        rankScheme.setVisible(true);
        rankScheme.getForm();
    }

    doDel(id) {
        const {
            rankScheme
        } = this.props;
        rankScheme.setIds(id);
        this.showConfirm('del');
    }


    log = () => {
        window.setLogViewProp({
            logMoudleType: 1,
            keys: new Date().getTime(),
        });
    }


    handleSave() {
        const {
            rankScheme
        } = this.props;
        const {
            isNew
        } = rankScheme;

        isNew && rankScheme.save();
        !isNew && rankScheme.edit();
    }

    getPanelComponents() {
        const {
            rankScheme
        } = this.props;
        const {
            searchCondition,
            form2,
            searchConditionLoading
        } = rankScheme;

        let arr = [];
        let formParams = form2.getFormParams();
        const {
            isFormInit
        } = form2;

        isFormInit && searchCondition.map(c => {
            c.items.map((field, index) => {
                arr.push(<Col ecId={`${this && this.props && this.props.ecId || ''}_Col@4cc308@${index}`} span={(index % 2 == 0) ? 10 : 11} offset={1}>
                    <div style={{ marginTop: 20 }}>
                        <WeaFormItem ecId={`${this && this.props && this.props.ecId || ''}_WeaFormItem@u6ex85@${index}`}
                            label={`${field.label}`}
                            labelCol={{ span: `${field.labelcol}` }}
                            wrapperCol={{ span: `${field.fieldcol}` }}>
                            {<WeaSwitch ecId={`${this && this.props && this.props.ecId || ''}_WeaSwitch@p7d3td@${index}`} fieldConfig={field} form={form2} formParams={formParams} />}
                        </WeaFormItem>
                    </div>
                </Col>)
            })
        })

        if (searchConditionLoading) {
            return (
                <div className='hrm-loading-center-small' style={{ top: '25%' }}>
                    <Spin ecId={`${this && this.props && this.props.ecId || ''}_Spin@lbktzb`} spinning={searchConditionLoading}></Spin>
                </div>
            )
        } else {
            return <Row ecId={`${this && this.props && this.props.ecId || ''}_Row@ppeb6z`} onKeyDown={(e) => {
                if (e.keyCode == 13 && e.target.tagName === "INPUT") {
                    rankScheme.getTableInfo();
                    rankScheme.setPanelStatus(false)
                }
            }}>{arr}</Row>
        }

    }

    //非空判断
    isEmptyObject(obj) {
        for (let key in obj) {
            return false;
        }
        return true;
    }




    render() {

        const {
            rankScheme
        } = this.props;
        const {
            isPanelShow, form2, schemeName, conditionNum, tableStore, nEdialogTitle, visible, condition,
            form, dialogLoading, isEdit, date, hasRight
        } = rankScheme;

        if (hasRight === false) {
            return renderNoright();
        }

        return (
            hasRight && <div ref='page' style={{ height: '100%' }}>
                <WeaRightMenu ecId={`${this && this.props && this.props.ecId || ''}_WeaRightMenu@k6oc4u`}
                    datas={this.getDropMenuDatas()}
                    onClick={key => this.handleMenuClick(key)}
                >
                    <WeaTop ecId={`${this && this.props && this.props.ecId || ''}_WeaTop@bj98s7`}
                        title={i18n.label.schemeName()}
                        icon={<i className='icon-coms-hrm' />}
                        iconBgcolor='#217346'
                        loading={true}
                        buttons={this.getTopMenuBtns()}
                        showDropIcon={true}
                        dropMenuDatas={this.getDropMenuDatas()}
                        onDropMenuClick={(e) => this.handleMenuClick(e)}
                    >
                        <WeaTab ecId={`${this && this.props && this.props.ecId || ''}_WeaTab@9c3zts`}
                            searchType={['base', 'advanced']}
                            showSearchAd={isPanelShow}
                            searchsBaseValue={this.isEmptyObject(form2.getFormParams()) ? schemeName : form2.getFormParams().schemeName}
                            setShowSearchAd={bool => rankScheme.setPanelStatus(bool)}
                            hideSearchAd={() => rankScheme.setPanelStatus(false)}
                            searchsAd={isPanelShow ? this.getPanelComponents() : <div></div>}
                            advanceHeight={Math.ceil(conditionNum / 2) * 52 + 20}
                            hasMask={false}
                            buttonsAd={this.getTabBtn()}
                            onSearch={() => rankScheme.getTableInfo()}
                            onSearchChange={val => this.onSearchChange(val)}
                        />
                        <WeaTable ecId={`${this && this.props && this.props.ecId || ''}_WeaTable@pgmg3x`}
                            comsWeaTableStore={tableStore}
                            hasOrder={true}
                            needScroll={true}
                            getColumns={c => this.reRenderColumns(c)}
                            onOperatesClick={(record, index, operate) => this.onOperatesClick(record, index, operate)}
                        />
                    </WeaTop>
                </WeaRightMenu>
                <NewAndEditDialog ecId={`${this && this.props && this.props.ecId || ''}_NewAndEditDialog@q4rrwm`}
                    title={nEdialogTitle}
                    visible={visible}
                    condition={toJS(condition)}
                    form={form}
                    isFormInit={form.isFormInit}
                    loading={dialogLoading}
                    isEdit={isEdit}
                    height={250}
                    conditionLen={1}
                    save={() => this.handleSave()}
                    onCancel={() => rankScheme.setVisible(false)}
                />
            </div>
        )
    }
}